/*
    Copyright (C) 2005-2012  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _CONFIG_GUI_H_
#define _CONFIG_GUI_H_

#include <glib.h>

typedef struct _config_gui_opts {
    gboolean show_notification_on_file_downloaded;
    gboolean show_notification_on_file_decoded;
    gboolean show_tray_icon;
    char hostname1[256];
    char hostname2[256];
    char hostname3[256];
    char hostname4[256];
    char hostname5[256];
    gboolean show_column_progress;
    gboolean show_column_subject;
    gboolean show_column_poster;
    gboolean show_column_newsgroups;
    gboolean show_column_filesize;
    gboolean show_column_filesize_remaining;
    gboolean show_column_stamp;
    gboolean show_column_time_remaining;
    gboolean show_column_time_to_finish;
    char auto_import_directory[256];
    gboolean enable_auto_import;
    char last_used_nzb_directory[256];
    gboolean show_connect_dialog;
    GList *auto_load_plugins;
    gboolean hide_inactive_connections;
} ConfigGUIOpts;

typedef struct ConfigGUI ConfigGUI;

ConfigGUIOpts    config_gui_get_opts(void);
void             config_gui_set_opts(ConfigGUIOpts new_opts);
ConfigGUI       *config_gui_get_object(void);

#endif /* _CONFIG_GUI_H_ */
