#include "ProgressBarDelegate.h"

#include <QStyleOptionProgressBarV2>
#include <QStyle>
#include <QApplication>
#include <assert.h>

#ifdef Q_OS_MACX
#include <QCleanlooksStyle>
#endif

ProgressBarDelegate::ProgressBarDelegate(QObject *parent)
	: QItemDelegate(parent)
{

}

ProgressBarDelegate::~ProgressBarDelegate()
{

}

void ProgressBarDelegate::paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    Q_UNUSED(option);

    QStyleOptionProgressBarV2 opts;
    int value = index.model()->data(index, Qt::DisplayRole).toInt();

    opts.state = QStyle::State_Active | QStyle::State_Enabled;
    opts.text = QString ("%1%").arg(value);
    opts.maximum = 100;
    opts.minimum =   0;
    opts.progress = value;
    opts.rect = option.rect;
    opts.rect.setRight(option.rect.right()-1);
    opts.rect.setHeight(option.rect.height()-1);
    opts.textVisible = true;
    opts.textAlignment = Qt::AlignCenter;

#ifdef Q_OS_MACX
    QCleanlooksStyle s;
    s.drawControl(QCleanlooksStyle::CE_ProgressBar, &opts, painter, 0);
#else
    QApplication::style()->drawControl(QStyle::CE_ProgressBar, &opts, painter);
#endif
}
