#ifndef WIDGETREPAIRANDUNPACK_H
#define WIDGETREPAIRANDUNPACK_H

#include <QWidget>
#include <QTreeWidgetItem>
#include "ProgressBarDelegatePAR2AndUnpack.h"
#include "QNNTPGrabGlue.h"

namespace Ui {
    class WidgetRepairAndUnpack;
}

class WidgetRepairAndUnpack : public QWidget {
    Q_OBJECT
public:
    WidgetRepairAndUnpack(QNNTPGrabGlue *glue, QWidget *parent = 0);
    ~WidgetRepairAndUnpack();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::WidgetRepairAndUnpack *ui;
    ProgressBarDelegatePAR2AndUnpack *progressbarDelegate;
    QNNTPGrabGlue *glue;
    QNNTPGrabGlue::ConfigOpts opts;

    QTreeWidgetItem *lookupCollection(QString collection_name);
    QTreeWidgetItem *lookupFilename(QTreeWidgetItem *collection_item, QString filename);
    void lookupCollectionAndFilename(QString collection_name, QString filename, QTreeWidgetItem **collection_item, QTreeWidgetItem **file_item);

    void par2BeginVerify(QString collection_name, QString active_par2_filename);
    void par2LoadProgressUpdate(QString collection_name, QString active_par2_filename, QString filename, double progress);
    void par2RecoveryFileLoaded(QString collection_name, QString active_par2_filename, QString filename, int num_new_packets, int num_blocks_found);
    void par2FileLoaded(QString collection_name, QString active_par2_filename, QString filename, QString state, int num_blocks_found, int num_blocks_expected);
    void par2RepairProgressUpdate(QString collection_name, QString active_par2_filename, double progress);
    void par2RepairFailure(QString collection_name, QString active_par2_filename, QString message, int num_blocks_more_required);
    void par2RepairSuccess(QString collection_name, QString active_par2_filename);
    void par2NoRepairRequired(QString collection_name, QString active_par2_filename);
    void unpackProgressUpdate(QString collection_name, QString filename, double progress);
    void unpackMessageReceived(QString collection_name, QString filename, QString message);
    void unpackWorkingArchiveChanged(QString collection_name, QString filename, QString working_archive);
    void unpackSuccess(QString collection_name, QString filename);
    void unpackFailure(QString collection_name, QString filename, QString reason);

private slots:
    void configChanged();
    void pluginEvent(QString plugin_name, QString event_name, QList<QString> values);
};

#endif // WIDGETREPAIRANDUNPACK_H
