/*
    Copyright (C) 2005-2012  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _NNTPCONNECTION_H_
#define _NNTPCONNECTION_H_

#include <sys/time.h>

#include "nntpconnection_backend_iface.h"

void                     nntpconnection_init_libproxy(void);
NNTPConnectionErrCode    nntpconnection_connect_to_server(NntpConnection *conn, char **errmsg);
void                     nntpconnection_disconnect_from_server(NntpConnection *conn, NNTPDisconnectType disconnect_type, const char *reason, const char *cause_file, int cause_lineno);
void                     nntpconnection_send_group_command(NntpConnection *conn);
void                     nntpconnection_send_body_command(NntpConnection *conn);
void                     nntpconnection_process_socket_activity(NntpConnection *conn);
void                     nntpconnection_process_welcome_msg(NntpConnection *conn);

#endif /* _NNTPCONNECTION_H_ */
