enum evilness
{
	N = 0,	/* no -- definitely safe characters */
	M = 1,	/* maybe -- extended characters, shell metacharacters, et c. */
	Y = 2	/* yes -- evil characters; characters not permitted by at least one FS (mainly FAT32 / NTFS) */
};

static const enum evilness char_evilness[0x100] =
{

	/* all control characters (< 0x20) are evil */
/*	NUL	SOH	STX	ETX	EOT	ENQ	ACK	BEL	*/
	Y,	Y, 	Y, 	Y, 	Y, 	Y, 	Y, 	Y,
/*	BS	HT	LF	VT	FF	CR	SO	SI	*/
	Y,	Y, 	Y, 	Y, 	Y, 	Y, 	Y, 	Y,
/*	DLE	DC1	DC2	DC3	DC4	NAK	SYN	ETB	*/
	Y,	Y, 	Y, 	Y, 	Y, 	Y, 	Y, 	Y,
/*	CAN	EM	SUB	ESC	FS	GS	RS	US	*/
	Y,	Y, 	Y, 	Y, 	Y, 	Y, 	Y, 	Y,

	/* and you thought these were mostly safe ... */
/*	SPC	!	"	#	$	%	&	'	*/
	N,	M,	Y,	M,	M,	M,	M,	M,
/*	(	)	*	+	,	-	.	/	*/
	M,	M,	Y,	N,	N,	N,	N,	Y,
/*	0	1	2	3	4	5	6	7	*/
	N,	N,	N,	N,	N,	N,	N,	N,
/*	8	9	:	;	<	=	>	?	*/
	N,	N,	Y,	M,	Y,	N,	Y,	Y,
/*	@	A	B	C	D	E	F	G	*/
	N,	N,	N,	N,	N,	N,	N,	N,
/*	H	I	J	K	L	M	N	O	*/
	N,	N,	N,	N,	N,	N,	N,	N,
/*	P	Q	R	S	T	U	V	W	*/
	N,	N,	N,	N,	N,	N,	N,	N,
/*	X	Y	Z	[	\	]	^	_	*/
	N,	N,	N,	M,	Y,	M,	N,	N,
/*	`	a	b	c	d	e	f	g	*/
	M,	N,	N,	N,	N,	N,	N,	N,
/*	h	i	j	k	l	m	n	o	*/
	N,	N,	N,	N,	N,	N,	N,	N,
/*	p	q	r	s	t	u	v	w	*/
	N,	N,	N,	N,	N,	N,	N,	N,
/*	x	y	z	{	|	}	~	DEL	*/
	N,	N,	N,	M,	Y,	M,	M,	Y,

/*	extended ASCII / UTF-8 escape sequences might be evil	*/
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M,
	M,	M, 	M, 	M, 	M, 	M, 	M, 	M

};

