/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/*
 *  File-Roller
 *
 *  Copyright (C) 2001, 2008 The Free Software Foundation, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 */

#ifndef FR_MIME_H
#define FR_MIME_H

const GPtrArray *fr_command_get_registered_commands(void);
void           fr_command_register_commands (void);

FrMimeTypeDescription 	*fr_mime_get_descriptions(void);
FrExtensionType		*fr_mime_get_extension_types(void);

GType        get_command_type_from_mime_type (const char    *mime_type,
				 	      FrCommandCaps  requested_capabilities);
const char * get_mime_type_from_extension    (const char    *ext);
const char * get_archive_filename_extension  (const char    *uri);
void         compute_supported_archive_types (void);

#endif /* FR_MIME_H */

